% Signal_loading.m

% experimental loading

% list = {'Acquisizione segnale custom 6 [23.10.2018].txt',...
%     'Acquisizione segnale custom 7 [23.10.2018].txt',...
%     'Acquisizione segnale custom 8 [24.10.2018].txt',...                   
% 'Acquisizione segnale custom 9 [24.10.2018].txt',...
% 'Acquisizione segnale custom 10 [24.10.2018].txt',...
% 'Acquisizione segnale custom 11 [24.10.2018].txt'};

list = {'Acquisizione riproduzione Test 1D_ 004.txt',...
        'Acquisizione riproduzione Test 1D_ 005.txt',...
        'Acquisizione riproduzione Test 2D_ 001.txt',...
        'Acquisizione riproduzione Test 2D_ 002.txt',...
        'Acquisizione riproduzione Test 2D_ 003.txt',...
        'Acquisizione riproduzione Test 3D_ 001.txt',...
        'Acquisizione riproduzione Test 3D_ 002.txt',...
        'Acquisizione riproduzione Test 3D_ 003.txt',...
        'Acquisizione riproduzione Test 4D_ 001.txt',...
        'Acquisizione riproduzione Test 4D_ 002.txt',...
        'Acquisizione riproduzione Test 5D_ 001.txt'};

[indx,tf] = listdlg('PromptString','Select a file:','ListString',list,'ListSize',[250,80]);

Acq=load(list{indx});

exp.set=Acq(:,1);
exp.fb=Acq(:,2);
exp.LVT=Acq(:,3);
exp.err_comp=Acq(:,4);
exp.PA=Acq(:,5);
exp.PB=Acq(:,6);
exp.PS=Acq(:,7);
exp.encoder=Acq(:,8);
exp.EMA_set=Acq(:,9);
exp.EMA_fb=Acq(:,10);
exp.f=1e3;
exp.t=linspace(0,length(exp.set)/exp.f,length(exp.set));

% signal conversion

PT.K=35;                                 % [bar/V] Pressure transducer gain
LVT.K=100;                               % [mm/sV] LVT gain
LVT.offset=0.055;                        % [V] LVT offset
EMA.K=5;                                 % [mm/V] EMA gain
LC.K=5000;                               % [N/V] LC + Dathafort gain
exp.set=exp.set;                         %[N] HLA set
exp.fb=exp.fb*LC.K;                      %[N] HLA fb
exp.LVT=(exp.LVT+LVT.offset)*LVT.K;      %[mm/s] LVT
exp.err_comp=exp.err_comp;               %[V] error comp.
exp.PA=exp.PA*PT.K;                      %[bar] pressure PA
exp.PB=exp.PB*PT.K;                      %[bar] pressure PB
exp.PS=exp.PS*PT.K;                      %[bar] pressure PS
exp.encoder=exp.encoder;                 %[deg] encoder
exp.EMA_set=exp.EMA_set;                 %[mm] EMA set
exp.EMA_fb=exp.EMA_fb*EMA.K;             %[mm] EMA fb

% filtering

[b_butter,a_butter]=butter(8,30/500,'low');
exp.LVT=filtfilt(b_butter,a_butter,exp.LVT);  
exp.err_comp=filtfilt(b_butter,a_butter,exp.err_comp); 
exp.PA=filtfilt(b_butter,a_butter,exp.PA); 
exp.PB=filtfilt(b_butter,a_butter,exp.PB);
exp.PS=filtfilt(b_butter,a_butter,exp.PS); 
exp.EMA_fb=filtfilt(b_butter,a_butter,exp.EMA_fb);         

StopTime=exp.t(end);
% set_param('banco_ASTIB_servocomandi_prj_ASTIB_140_no_lineare','StopTime','StopTime')


